package cn.wch.ch34xMultiUartDemo;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbManager;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import java.util.concurrent.Semaphore;

import cn.wch.lib.ch34xMultiDriver;
import cn.wch.lib.ch34xMultiManager;

public class MainActivity extends AppCompatActivity implements View.OnClickListener{
    private Button open;
    private Button config;
    private Button clear;
    private Button write;
    private Spinner sp_baud,sp_stop,sp_data,sp_flow,sp_parity;
    private int baud;
    private byte stop,data,flow,parity;
    private EditText Recv,Recv1;
    private EditText Send;
    Boolean IsOpen=false;//
    //////////////////////////////////////////////////////////
    private Handler handler;
    private UsbManager manager;
    public Semaphore Sem=new Semaphore(1);
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.main);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        open=(Button)findViewById(R.id.OpenClose);
        config=(Button)findViewById(R.id.Config);
        write=(Button)findViewById(R.id.Write);
        clear=(Button)findViewById(R.id.Clear);
        Recv=(EditText)findViewById(R.id.edit_read);
        Recv1=(EditText)findViewById(R.id.edit_read1);
        Send=(EditText)findViewById(R.id.edit_write);
        open.setOnClickListener(this);
        config.setOnClickListener(this);
        write.setOnClickListener(this);
        clear.setOnClickListener(this);
        initSpinner();

        handler=new Handler(){
            public void handleMessage(Message msg){
                if (msg.what==0) {
                    Recv.append((String) msg.obj);
                }else if(msg.what==1){
                    Recv1.append((String) msg.obj);
                }
            }

        };

        manager=(UsbManager)getSystemService(Context.USB_SERVICE);
        MyApp.ch34xmag=new cn.wch.lib.ch34xMultiManager(getApplicationContext(),manager);
        if (!UsbFeatureSupported())// 是否支持USB HOST
        {
            Dialog dialog = new AlertDialog.Builder(MainActivity.this)
                    .setTitle("提示")
                    .setMessage("设备不支持USB HOST")
                            .setPositiveButton("确定",
                                    new DialogInterface.OnClickListener() {

                                        @Override
                                        public void onClick(DialogInterface arg0,
                                                            int arg1) {
                                            System.exit(0);
                                        }
                                    }).create();
            dialog.setCanceledOnTouchOutside(false);
            dialog.show();
        }
    }
    public boolean UsbFeatureSupported()
    {
        boolean bool = MainActivity.this.getPackageManager().hasSystemFeature("android.hardware.usb.host");
        return bool;
    }
    public void initSpinner(){
        /*****baud*******/
        sp_baud=(Spinner)findViewById(R.id.spinner_baud);
        ArrayAdapter<CharSequence> dapter=ArrayAdapter.createFromResource(this, R.array.baud, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_baud.setAdapter(dapter);
        sp_baud.setSelection(9);
        baud=115200;
        /*****stop*******/
        sp_stop=(Spinner)findViewById(R.id.spinner_stop);
        ArrayAdapter<CharSequence> dapter1=ArrayAdapter.createFromResource(this, R.array.stop, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_stop.setAdapter(dapter1);
        sp_stop.setSelection(0);
        stop=1;
        /******data******/
        sp_data=(Spinner)findViewById(R.id.spinner_data);
        ArrayAdapter<CharSequence> dapter2=ArrayAdapter.createFromResource(this, R.array.data, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_data.setAdapter(dapter2);
        sp_data.setSelection(3);
        data=8;
        /*****parity*******/
        sp_parity=(Spinner)findViewById(R.id.spinner_parity);
        ArrayAdapter<CharSequence> dapter3=ArrayAdapter.createFromResource(this, R.array.parity, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_parity.setAdapter(dapter3);
        parity=0;
        /*****flow*******/
        sp_flow=(Spinner)findViewById(R.id.spinner_flow);
        ArrayAdapter<CharSequence> dapter4=ArrayAdapter.createFromResource(this, R.array.flow, R.layout.spinner_textview);
        dapter.setDropDownViewResource(R.layout.spinner_textview);
        sp_flow.setAdapter(dapter4);
        flow=0;
        ///////
        ///
        sp_baud.setOnItemSelectedListener(new MyOnBaudSelectedListener());
        /* set the adapter listeners for stop bits */
        sp_stop.setOnItemSelectedListener(new MyOnStopSelectedListener());
        /* set the adapter listeners for data bits */
        sp_data.setOnItemSelectedListener(new MyOnDataSelectedListener());
        /* set the adapter listeners for parity */
        sp_parity.setOnItemSelectedListener(new MyOnParitySelectedListener());
        /* set the adapter listeners for flow control */
        sp_flow.setOnItemSelectedListener(new MyOnFlowSelectedListener());
        ///////
    }
    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.OpenClose:
                int  mRet=0;
                if(!IsOpen){
                    if(MyApp.ch34xmag==null) {
                        MyApp.ch34xmag = new ch34xMultiManager(getApplicationContext(), manager);
                    }
                    Toast.makeText(this,"device Num:"+MyApp.ch34xmag.usbDeviceList.size(),Toast.LENGTH_SHORT).show();
                    if(MyApp.ch34xmag.usbDeviceList.size()==0){
                        Toast.makeText(this,"No device",Toast.LENGTH_SHORT).show();
                        break;
                    }
                    for(int i=0;i<MyApp.ch34xmag.usbDeviceList.size();i++){
                        Log.d("permission","Open"+MyApp.ch34xmag.usbDeviceList.get(i).getDeviceName());
                        if(!MyApp.ch34xmag.OpenUsbDevice(MyApp.ch34xmag.usbDeviceList.get(i))){
                            mRet++;
                        }
                    }
                    if(mRet!=0){
                        Toast.makeText(this,"打开失败，请授权或者重试",Toast.LENGTH_SHORT).show();
                        MyApp.ch34xmag=null;
                        break;
                    }
                    open.setText("Close");
                    IsOpen=true;
                    Log.d("permission","readthread start");
                    new readthread().start();
                }
                else{
                    IsOpen=false;//退出readthread
                    MyApp.ch34xmag.CloseAll();//unregisterBroadcast
                    open.setText("Open");

                    MyApp.ch34xmag=null;
                }
                break;
            case R.id.Config:
                if(!IsOpen){
                    Toast.makeText(this,"Not Open",Toast.LENGTH_SHORT).show();
                    break;
                }
                for(int i=0;i<MyApp.ch34xmag.ch34xDriverList.size();i++){
                    if(MyApp.ch34xmag.ch34xDriverList.get(i).SetConfig(baud,data,stop,parity,flow)){
                        Toast.makeText(this, "Config Success", Toast.LENGTH_SHORT).show();
                    }else{
                        Toast.makeText(this, "Config Fail", Toast.LENGTH_SHORT).show();
                    }
                }
                break;
            case R.id.Clear:
                Recv.setText("");
                Recv1.setText("");
                break;
            case R.id.Write:
                if(!IsOpen){
                    Toast.makeText(this,"Not Open",Toast.LENGTH_SHORT).show();
                    break;
                }
                byte[] To_Send=ToByteArray(Send.getText().toString());
                ch34xMultiDriver ch34xdriver;
                Toast.makeText(this,"发给"+MyApp.ch34xmag.ch34xDriverList.size()+"个设备",Toast.LENGTH_SHORT).show();
                for(int i=0;i<MyApp.ch34xmag.ch34xDriverList.size();i++){
                    Log.d("tag","write"+MyApp.ch34xmag.ch34xDriverList.size());
                    ch34xdriver=MyApp.ch34xmag.ch34xDriverList.get(i);
                    int retval=ch34xdriver.WriteData(To_Send, To_Send.length);
                }
                break;
        }
    }
    //////////////Spinner///////////////
    public class MyOnBaudSelectedListener implements AdapterView.OnItemSelectedListener {

        @Override
        public void onItemSelected(AdapterView<?> parent, View view,
                                   int position, long id) {
            baud = Integer.parseInt(parent.getItemAtPosition(position)
                    .toString());
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }
    }
    public class MyOnStopSelectedListener implements AdapterView.OnItemSelectedListener {

        @Override
        public void onItemSelected(AdapterView<?> parent, View view,
                                   int position, long id) {
            stop = (byte) Integer.parseInt(parent
                    .getItemAtPosition(position).toString());
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }

    }
    public class MyOnDataSelectedListener implements AdapterView.OnItemSelectedListener {

        @Override
        public void onItemSelected(AdapterView<?> parent, View view,
                                   int position, long id) {
            data = (byte) Integer.parseInt(parent
                    .getItemAtPosition(position).toString());
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }

    }
    public class MyOnParitySelectedListener implements AdapterView.OnItemSelectedListener {

        @Override
        public void onItemSelected(AdapterView<?> parent, View view,
                                   int position, long id) {
            String parityString = new String(parent.getItemAtPosition(position)
                    .toString());
            if (parityString.compareTo("None") == 0) {
                parity = 0;
            }

            if (parityString.compareTo("Odd") == 0) {
                parity = 1;
            }

            if (parityString.compareTo("Even") == 0) {
                parity = 2;
            }

            if (parityString.compareTo("Mark") == 0) {
                parity = 3;
            }

            if (parityString.compareTo("Space") == 0) {
                parity = 4;
            }
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }

    }
    public class MyOnFlowSelectedListener implements AdapterView.OnItemSelectedListener {

        @Override
        public void onItemSelected(AdapterView<?> parent, View view,
                                   int position, long id) {
            String flowString = new String(parent.getItemAtPosition(position).toString());
            if (flowString.compareTo("None") == 0) {
                flow = 0;
            }

            if (flowString.compareTo("CTS/RTS") == 0) {
                flow= 1;
            }
        }

        @Override
        public void onNothingSelected(AdapterView<?> parent) {

        }

    }
    private byte[] ToByteArray(String arg){
        if(arg!=null){
            char[] NewArray=new char[1000];
            char[] array=arg.toCharArray();
            int length=0;
            for(int i=0;i<array.length;i++){
                if(array[i]!=' '){
                    NewArray[length]=array[i];
                    length++;
                }
            }
            int EvenLength=(length%2==0)?length : length+1;
            if(EvenLength!=0){
                int[] data=new int[EvenLength];
                data[EvenLength-1]=0;
                for(int i=0;i<length;i++){
                    if(NewArray[i]>='0' && NewArray[i]<='9'){
                        data[i]=NewArray[i]-'0';
                    }else if(NewArray[i]>='a' && NewArray[i]<='f'){
                        data[i]=NewArray[i]-'a'+10;
                    }else if(NewArray[i]>='A' && NewArray[i]<='F'){
                        data[i]=NewArray[i]-'A'+10;
                    }
                }
                byte[] byteArray=new byte[EvenLength/2];
                for(int i=0;i<EvenLength/2;i++){
                    byteArray[i]=(byte)(data[i*2]*16+data[i*2+1]);
                }
                return byteArray;
            }
        }
        return new byte[]{};
    }
    private String toHexString(byte[] arg,int length){
        String result=new String();
        if(arg!=null){
            for(int i=0;i<length;i++){
                result=result+((Integer.toHexString(arg[i] < 0 ?arg[i]+256:arg[i]).length()==1 ? ("0"+Integer.toHexString(arg[i] < 0 ?arg[i]+256:arg[i])) : (Integer.toHexString(arg[i] < 0 ?arg[i]+256:arg[i])))+" ");
            }
            return result;
        }
        return "";
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        MyApp.ch34xmag.CloseAll();
    }
    private class readthread extends Thread{
        public void run(){
            byte[] buffer=new byte[4096];
            String recv;
            while((true&&IsOpen)){
                //收发数据过程中移除设备，调用MyApp.ch34xmag.ch34xDriverList.remove(),用信号量防止同时访问
                try{
                    MyApp.ch34xmag.SemDriverList.acquire();
                }catch (InterruptedException e){
                    e.printStackTrace();
                }
                for(int i=0;i<MyApp.ch34xmag.ch34xDriverList.size();i++) {
                    int len = 0;
                    len = MyApp.ch34xmag.ch34xDriverList.get(i).ReadData(buffer, 4096);
                    if (len > 0) {
                        Message msg=Message.obtain();
                        recv = toHexString(buffer, len);
                        msg.obj= (Object)recv;
                        msg.what=i;
                        handler.sendMessage(msg);
                    }
                }
                MyApp.ch34xmag.SemDriverList.release();
            }
            Log.d("MainActicity", "End readthread");
        }
    }
}

